/*=================================================================
xAtɕ\

2010.09.24	Ver1.2 AMRfqɑΉ
2010.09.04	Ver1.1 ኱
2010.09.02	eC˗
2010.08.20	et
2010.08.16	Ver1.0
2010.08.13	vOJn
2010.08.12	Jn
2010.08.06	H݌v
2010.08.02	ł킹
2010.06.24	˗
=================================================================*/
#include <P18F14K50.h>
#include "lcd.h"
#include "pole.h"

// Configration bits
//#pragma config CPUDIV = NOCLKDIV	// Fosc:8MHz
#pragma config CPUDIV = CLKDIV2		// Fosc:4MHz
#pragma config USBDIV = OFF
#pragma config FOSC   = IRC			// ddł͐sɂȂ̂œRCIV[^g
#pragma config PLLEN  = OFF			// PLL disableAdጸ̂ߑȂ
//#pragma config PLLEN  = ON			// PLL enable
#pragma config FCMEN  = OFF
#pragma config IESO   = OFF
#pragma config PWRTEN = ON			// Power On ^C}gp
#pragma config BOREN  = ON			// dZbggp
#pragma config BORV   = 22			// d́A2.2V
#pragma config WDTPS  = 128
#pragma config WDTEN  = ON			// EHb`hbO^C}gp
#pragma config MCLRE  = OFF
#pragma config HFOFST = OFF
#pragma config STVREN = ON
#pragma config LVP    = OFF
#pragma config XINST  = OFF
#pragma config BBSIZ  = OFF
#pragma config CP0    = OFF
#pragma config CP1    = OFF
#pragma config CPB    = OFF
#pragma config WRT0   = OFF
#pragma config WRT1   = OFF
#pragma config WRTB   = OFF
#pragma config WRTC   = OFF
#pragma config EBTR0  = OFF
#pragma config EBTR1  = OFF
#pragma config EBTRB  = OFF       

//-----------------------------------------------------------------------------------
// ZT̎ gpZT̖̂`
//#define KMZ10B
#define HW300A
//#define THS130

// KMZ10B philips ̐ݒ d8mA
#ifdef KMZ10B
// ADC̕ϊݒ
// 1:500Hz,  2:250Hz,  3:125Hz,  4:62.5Hz, 5:50Hz, 6:39.2Hz, 7:33.3Hz
// 8:19.6Hz, 9:16.7Hz, a:16.7Hz, b:12.5Hz, c:10Hz, d:8.33Hz, e:6.25Hz, f:4.17Hz
#define PERIOD (0x8)
#define AVRNUM (2)	// ̕ω
// ADC̃QCݒl 2^GAIN
// 3 --> 2^3 = 8{
#define GAIN	 (3)
// KMZ10B̃f[^V[g̊x́AWl4(mV/V)/(kA/m)
// 1kA/m = 1.25mT = 1250uT Ȃ̂
// 1uTɑ΂ADC̏o͒ĺA0.004V x 2^24 x  / 1250 = 53.69 * GAIN
// DDIGTŕ\Pʂ߂ 100:1uTPʁA1000:0.1uTA10000:0.01uT
#define UNTSTR "UNIT 0.1uT  "
#define DDIGT (1000L)
#define SENS (5369L * (1L<<GAIN) / DDIGT)
#endif

// HW-300A  ̐ݒ d 20mA
#ifdef HW300A
#define PERIOD (0x8)
#define AVRNUM (2)	// ̕ω
#define GAIN	 (1)
// xɕϊ邽߂̒萔B\TPʂƂBf[^V[g犷ZB
// fqd1V̎Ax0.05TŃz[d0.2V
// AvQClĕϊ萔Zo
#define UNTSTR "UNIT 1uT    "
#define SENS (20L * (1L<<GAIN) * (1L<<10) / 10L / 61L)
#endif

// HTS-130 Toshiba ̐ݒ
#ifdef THS130
#define PERIOD (0x4)
#define AVRNUM (20)	// ̕ω
#define GAIN	 (3)
// xɕϊ邽߂̒萔B\TPʂƂBf[^V[g犷ZB
// fqd5.2V̂ƂAx0.1TŃz[d=0.16V
// AvQClĕϊ萔Zo
#define UNTSTR "UNIT 1uT    "
#define SENS (16L * (1L<<GAIN) * (1L<<10) / 52L / 61L)
#endif
//-----------------------------------------------------------------------------------

#define OFSNUM (16)	// ItZbg𑪒肷
#define AXIS_X (1)		// XZT̃`lԍ
#define AXIS_Y (0)		// YZT̃`lԍ

#define TRUE (1 == 1)
#define FALSE (! TRUE)

#define	AD_CS	LATCbits.LATC6		// AD7793 /CS
#define	AD_RDY	PORTBbits.RB4

#define adIsReady() (PORTBbits.RB4 == 0)
#define adIsBusy() (PORTBbits.RB4 == 1)
#define CsOn() (LATCbits.LATC6 = 0)
#define CsOff() (LATCbits.LATC6 = 1)

// 萔AvO̕񂪈ɂ̂RAMɒuB
char str1[] = UNTSTR;
char str_ox[] = "ox:*********";
char str_oy[] = "oy:*********";
char str_xy[] = "*******X*******Y";
char str_rt[] = "*******R*******T";
char str_zr[] = "      0R ----- T";

// ADC֘AWX^̏ݒ
void ADCInit(void)
{
	ANSEL = 0x0;			// AN3..7 ׂăfW^
	ANSELH = 0x0;			// AN8..11
	ADCON0 = 0x0;
	ADCON1 |= 0x0f;		// ׂĂfW^
	// RC6	/CS
	// RB1	/RDY
	TRISCbits.TRISC7 = 0;
	TRISCbits.TRISC6 = 0;

	TRISBbits.TRISB6 = 0;
	TRISBbits.TRISB4 = 1;

	// SPȈ
	SSPSTAT = 0x01;		// SMP:0,CKE:0,BF:full
	SSPCON1 = 0x30;		// NonWC,SSPon,CKP:1,Fosc
}

// SPIɂ鑗M
// MƎM͓ɍs
// ADCMɐݒ肳Ă΃f[^ǂݍ܂
// AMɐݒ肳΁A炩̑Mf[^͎̂Ă
unsigned char AdcCom(unsigned char data)
{
	unsigned char ret;
	// SPĨobt@ɂȂ̂҂
	while(SSPSTATbits.BF == 1){
	}
	// obt@ɏނ8bit̑Mn܂
	SSPBUF = data;
	// obt@ɎMf[^܂ő҂
	while(SSPSTATbits.BF == 0){
	}
	ret = SSPBUF;
	PIR1bits.SSPIF = 0;	
	return ret;
}

// ADC̕ϊI҂24bitf[^荞
long AdcRead(void)
{
	long g;
	
	while(adIsBusy()){
	}
	ClrWdt();
	AdcCom(0x58);
	g = AdcCom(0x0);
	g = (g << 8) | AdcCom(0x0);
	g = (g << 8) | AdcCom(0x0);
	return g;
}

// `l؂ւ
// ؂ւAl肷܂łRȏǂ݂Kv
void AdcCh(char ch)
{
	char a;
	// ݒ背WX^
	while(adIsBusy()){
	}
	AdcCom(2 << 3);
	AdcCom(0x00 | GAIN);		// Gain:
	AdcCom(0x10 | ch);
	for(a = 0; a < 2; a++){
		AdcRead();
	}	
}

// --------------------------------------------------------
// 荞ݏ
// ZɎԂ̂ŁAv͊荞݂ōsB
// --------------------------------------------------------
char dataIsReady = FALSE;
void int_rb4 (void);

// 荞݃AhXɊ荞ݏւ̈ړ߂
#pragma code InterruptVector = 0x08
void InterruptVector (void) {
	_asm
		goto int_rb4
	_endasm
}
#pragma code

// 荞ݓŎgp`lݒ֐
void intAdcCh(char ch)
{
	// ݒ背WX^
	AdcCom(2 << 3);
	AdcCom(0x00 | GAIN);		// Gain:
	AdcCom(0x10 | ch);
}

// 荞ݏĂ΂ADCf[^ǂݍ݊֐
long t;
void intAdcRead(void)
{
	AdcCom(0x58);
	t = AdcCom(0x0);
	t = (t << 8) | AdcCom(0x0);
	t = (t << 8) | AdcCom(0x0);
}

// 荞ݏɂXYz[fq
// ϑƃ`l؂ւXe[g}Vōs
#pragma interruptlow int_rb4
long x, y, ox, oy;
void int_rb4 (void) {
	static char state = 0;
	static char cnt = 0;
	static long sx = 0;
	static long sy = 0;

	// I`FW荞݂łȂΉȂ
	if(INTCONbits.RABIF == 0){
		return;
	}
	// 荞݃tO낷
	INTCONbits.RABIF = 0;
	// オGbWȂ牽Ȃ
	if(adIsBusy()){
		return;
	}

	IOCBbits.IOCB4 = 0;
	intAdcRead();
	switch(state){
	// xϒl
	case 0:
		sx += t;
		if(cnt++ >= AVRNUM-1){
			cnt = 0;
			x = sx / AVRNUM;
			sx = 0;
			intAdcCh(AXIS_Y);
			state = 1;
		}
		break;
	// `l؂ւ̃ZbgAbv
	// Q񕪂̃f[^ǂݎ̂Ă
	case 1:
		if(cnt++ > 1){
			cnt = 0;
			state = 2;
		}
		break;
	// yϒl
	case 2:
		sy += t;
		if(cnt++ >= AVRNUM-1){
			cnt = 0;
			y = sy / AVRNUM;
			intAdcCh(AXIS_X);
			sy = 0;
			state = 3;
			dataIsReady = TRUE;	// set TRUE
		}
		break;
	// `l؂ւ̃ZbgAbvԂ҂
	case 3:
		if(cnt++ > 1){
			cnt = 0;
			state = 0;
		}
		break;
	}
	IOCBbits.IOCB4 = 1;
}


// --------------------------------------------------------
// C֐
// --------------------------------------------------------
void main(void)
{
	unsigned char a, b, c;
	long arg;
	int deg;

	//------------------------------
	// t\̂߂̏ݒ
	//------------------------------
	LCDInit();
	LCDCont(10);	// RgXg

	ADCInit();	// ADC֘Ȁ
	CsOn();		// ADCI

	//------------------------------
	// ADC̏ݒ
	//------------------------------
	// 32ȏ1𑗐MAADCZbg
	for(a = 0; a < 5; a++){
		AdcCom(0xff);
	}
	delay_ms(1);
	while(adIsBusy()){
	}

	// [hWX^ݒ肷
	AdcCom(1 << 3);
	AdcCom(0x00);				// Aϊ[h
	AdcCom(0x00 | PERIOD);		// ϊݒ	

//	ltoa(str1, 11, 6, SENS);
	LCDputs1(str1);

	//------------------------------
	// v̂߂̏ݒ
	//------------------------------
	// ch0:x ̃ItZbg𑪒肷
	AdcCh(AXIS_X);
	ox = 0;
	for(a = 0; a < OFSNUM; a++){
		t = AdcRead();
		ox += t;
		strcpy(buf, str_ox);
		ltoa(buf, 11, 3, ox);
		LCDputs2(buf);
	}
	ox /= OFSNUM;

	// ch1:y ̃ItZbg𑪒肷
	AdcCh(AXIS_Y);
	oy = 0;
	for(a = 0; a < OFSNUM; a++){
		t = AdcRead();
		oy += t;
		strcpy(buf, str_oy);
		ltoa(buf, 11, 3, oy);
		LCDputs2(buf);
	}
	oy /= OFSNUM;

	// ADCRDY[qɂ銄荞݂ݒ肷
	IOCBbits.IOCB4 = 1;	// Interrupt on change RB4 enable
	INTCONbits.RABIE = 1;	// Interrupt on change RA,RB enable
	INTCONbits.GIE = 1;

	//------------------------------
	// ̂߂̖[v
	// 荞݂ōsvƃ[v̐lZ͕񏈗	
	//------------------------------
	strcpy(buf, str_xy);
	strcpy(buf2, str_rt);
	while(1){
		// 荞ݏɂ鑪肪Î҂
		// 荞݂͌vZI҂Ɏ̌vJn
		if(dataIsReady){
			dataIsReady = FALSE;
			// ItZbgBuTPʂւ̕ϊ͋ɍWϊ
			sx = (x - ox) / SENS;
			sy = (y - oy) / SENS;
			// \
			ltoa( buf, 6, 0, sx); ltoa( buf, 14, 8, sy);
			if(sx != 0 || sy != 0){
				// ɍW֕ϊ
				poleConv();
				ltoa(buf2, 6, 0, amp ); ltoa(buf2, 14, 8, phase);
			}else{
				strcpy(buf2, str_zr);
			}	
			LCDputs1(buf);
			LCDputs2(buf2);
		}
		ClrWdt();		// ԌZbg
	}
}