/*=================================================================
	tfBXvCւ̏o

	tƂ̐ڑ
	CCP1		PWMɂtp̕d𔭐
	RC1		DB4@tf[^A4rbg[hgp
	RC2		DB5
	RC3		DB6
	RC4		DB7
	RB7		RegSel
	DB5		ENBL
=================================================================*/
#include <P18F14K50.h>
#include "lcd.h"

#define Enbl1() (PORTB = LATB |  0x20)
#define Enbl0() (PORTB = LATB & ~0x20)
#define RegSel1() (PORTB = LATB |  0x80)
#define RegSel0() (PORTB = LATB & ~0x80)

void delay_ms (long wtime)
{
	long w = 0;
	for (w = 0; w < wtime*2; w++){
		Delay10TCYx(1);
	} 
}


// d ̉4rbgo
void LCDOutNibble(char d)
{
	PORTC = (LATC & ~0x1e) | (d << 1) & 0x1e;
	Enbl1();
	Enbl0();	
}

// dʃoCgƉʃoCgɕďo
void LCDOutByte(char d)
{
	LCDOutNibble(d >> 4);
	LCDOutNibble(d);
}

void LCDInit(void)
{
	// p|[go͂ɐݒ 0:output
	TRISC &= ~0x1e;	// RC1..RC4 -> output
	TRISB &= ~0xa0;	// RB7, RB5 -> output

	// dpPWMJn
	// CCP1CON P1M1 P1M0 DC1B1 DC1B0 CCP1M3 CCP1M2 CCP1M1 CCP1M0
	//            0    0     0     0      1      1      0      0
	CCP1CON = 0x0c;
	TRISC &= ~0x20;	// RC5/CCP1 -> output
	//PSTRCON = 0x11;

	PR2 = 99;			// PWM
	CCPR1L = 10;		// pX
	// T2CON - T2OUTPS3 T2OUTPS2 T2OUTPS1 T2OUTPS0 TMR2ON T2CKPS1 T2CKPS0
	//       0        0        0        0        0      1       0       0
	T2CON = 0x04;		// timer2 ON


	// LCD̏n߂
	RegSel0();
	Enbl0();	
	delay_ms(20);

	// ǂ̂悤ȏԂ8bit[hֈڍs
	LCDOutNibble(0x03);
	delay_ms(5);
	LCDOutNibble(0x03);
	delay_ms(1);
	LCDOutNibble(0x03);
	delay_ms(1);
	// 4bit[hֈڍs
	LCDOutNibble(0x02);
	delay_ms(1);
	LCDOutByte(0x2c);	// 2s\[h
	LCDOutByte(0x0c);	// clear
	LCDOutByte(0x01);	// clear
	delay_ms(2);
	LCDOutByte(0x06);	// ̓[hA݌Eֈړ
	
}

char buf[16];
char buf2[16];
void LCDputs1(char *s)
{
	char a;
	RegSel0();
	LCDOutByte(0x80);	// 1sڂ̐擪A0xc0Ȃ2sڂ̐擪
	RegSel1();
	for(a = 0; a < 16; a++){
		LCDOutByte(*s++);
		if(*s == '\0'){
			break;
		}
	}
}

void LCDputs2(char *s)
{
	char a;
	RegSel0();
	LCDOutByte(0xc0);	// 1sڂ̐擪A0xc0Ȃ2sڂ̐擪
	RegSel1();
	for(a = 0; a < 16; a++){
		LCDOutByte(*s++);
		if(*s == '\0'){
			break;
		}
	}
}

// long̐l𕶎ɕϊ
// s[tail]珑n߂Bʂʂ֏ށB
// s[head]܂ł̓Xy[XŖ߂
void ltoa(char* s, char tail, char head, long d)
{
	char sign = 0;
	// d == 0 Ȃ[
	if(d == 0){
		s[tail--] = '0';
	}else{
		// L^̐͐
		if(d < 0){
			d = -d;
			sign = 1;
		}
		// ʂ̌珇Ԃɕϊ
		while(d > 0){
			s[tail--] = d % 10 + '0';
			d /= 10;
		}
		// }CiXL̒ǉ
		if(sign == 1){
			s[tail--] = '-';
		}
	}
	// c̏ʌXy[XŖ߂
	while(tail >= head){
		s[tail--] = ' ';
	}
}
